package com.kuxuan.fastbrowser;

import android.app.Application;

import com.facebook.stetho.Stetho;
import com.joanzapata.iconify.fonts.FontAwesomeModule;
import com.kuxuan.laraver.app.Laraver;
import com.kuxuan.laraver.browser.database.DatabaseManager;
import com.kuxuan.fastbrowser.event.TextEvent;
import com.kuxuan.laraver.net.interceptors.ReleaseInterceptor;

import cn.jpush.android.api.JPushInterface;

/**
 *
 * @author huangfuruixin
 * @date 2017/12/5
 */

public class App extends Application {
    @Override
    public void onCreate() {
        super.onCreate();
        Laraver.init(this)
                .withApiHost("http://114.67.235.114/RestServer/api/")
                .withIcon(new FontAwesomeModule())
                .withJavascriptInterface("Laraver")
                .withWeChatAppId("wxfcdcecd9df8e0faa")
                .withWeChatAppSecret("a0560f75335b06e33bea70f29ff219bf")
                .withWebEvent("Laraver",new TextEvent())
                .withInterceptor(new ReleaseInterceptor())
                .withWebHost("https://wwww.baidu.com/")
                .configure();
        DatabaseManager.getInstance().init(this);
        //开启极光推送
        JPushInterface.setDebugMode(true);
        JPushInterface.init(this);

    }

    private void initStetho() {
        Stetho.initialize(
                Stetho.newInitializerBuilder(this)
                        .enableDumpapp(Stetho.defaultDumperPluginsProvider(this))
                        .enableWebKitInspector(Stetho.defaultInspectorModulesProvider(this))
                        .build());
    }
}
