package com.kuxuan.laraver.app;

import com.kuxuan.laraver.util.storage.LaraverPreference;

/**
 * @author huangfuruixin
 */
public class AccountManager {

    private enum SignTag {
        SIGN_TAG
    }

    //保存用户登录状态，登录后调用
    public static void setSignState(boolean state) {
        LaraverPreference.setAppFlag(SignTag.SIGN_TAG.name(), state);
    }


    private static boolean isSignIn() {
        return LaraverPreference.getAppFlag(SignTag.SIGN_TAG.name());
    }

    /**
     *
     * @param checker
     */
    public static void checkAccount(IUserChecker checker) {
        if (isSignIn()) {
            checker.onSignIn();
        } else {
            checker.onNotSignIn();
        }
    }
}