package com.kuxuan.laraver.delegates.web;

import android.webkit.JavascriptInterface;

import com.alibaba.fastjson.JSON;
import com.kuxuan.laraver.util.log.LaraverLogger;
import com.kuxuan.laraver.delegates.web.event.Event;
import com.kuxuan.laraver.delegates.web.event.EventManager;

final class LaraverWebInterface {
    private final WebDelegate DELEGATE;

    private LaraverWebInterface(WebDelegate delegate) {
        this.DELEGATE = delegate;
    }

    static LaraverWebInterface create(WebDelegate delegate) {
        return new LaraverWebInterface(delegate);
    }

    @SuppressWarnings("unused")
    @JavascriptInterface
    public String event(String params) {
        final String action = JSON.parseObject(params).getString("action");
        final Event event = EventManager.getInstance().createEvent(action);
        LaraverLogger.d("WEB_EVENT",params);
        if (event != null) {
            event.setAction(action);
            event.setDelegate(DELEGATE);
            event.setContext(DELEGATE.getContext());
            event.setUrl(DELEGATE.getUrl());
            return event.execute(params);
        }
        return null;
    }
}