package com.kuxuan.laraver.net.interceptors;

import com.kuxuan.laraver.util.storage.LaraverPreference;

import java.io.IOException;

import io.reactivex.functions.Consumer;
import okhttp3.Request;
import okhttp3.Response;

/**
 * @author huangfuruixin
 */
public final class ReleaseInterceptor extends BaseInterceptor {
    @Override
    public Response intercept(Chain chain) throws IOException {
        final Request.Builder builder = chain.request().newBuilder();
        io.reactivex.Observable.just(LaraverPreference.getCustomAppProfile("cookie"))
                .subscribe(new Consumer<String>() {
                    @Override
                    public void accept(String cookies) throws Exception {
                        //给原生API请求附带上webView拦截下来的请求
                        builder.addHeader("Cookie",cookies);
                        builder.addHeader("Content-Type", "application/json");
                    }
                });

        // 返回
        return chain.proceed(builder.build());
    }
}
